#ifndef EVAL_FLATTEN_H
#define EVAL_FLATTEN_H

#include "eval_op.h"

typedef std::map<std::string, std::shared_ptr<eval_op>> eval_op_proto_map;

class eval_flatten: public eval_op {
    tensor value_;
    std::shared_ptr<eval_op> clone(const expression &expr) override;
public:
    eval_flatten () {}
    eval_flatten(const expression &expr);
    void eval(vars_type &variables, const kwargs_type &kwargs) override;
    static void store_prototype(eval_op_proto_map &proto_map) {
        assert(proto_map.find("Flatten") == proto_map.end());
        proto_map["Flatten"] = std::make_shared<eval_flatten>(); // where is expr?
    }
}; // class eval_flatten

#endif